<?php
/*
Plugin Name: jQuery Reply to Comment
Plugin URI: http://wordpress.org/extend/plugins/jquery-reply-to-comment/
Description: Add "reply" and "quote" features on each comment list by jQuery. Thanks to <a target="_blank" href="http://www.cristianofino.net/post/Comment-toolbar-plugin-per-Wordpress.aspx">Cristiano Fino's Plugin</a> for original idea. See <a href="options-general.php?page=jqr2c.php">configuration panel</a> for more settings. Visit my Blog <a href="http://www.undolog.com">Undolog.com</a> for others plugin
Version: 1.31
Author: Giovambattista Fazioli
Author URI: http://www.undolog.com/
Disclaimer: Use at your own risk. No warranty expressed or implied is provided.
*/

/* 
	Copyright 2009 Saidmade srl (email : g.fazioli@saidmade.com)

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

define('JQR2C_OPTIONSKEY',	'jqr2c_settings');
define('JQR2C_VERSION',		'1.31');

define( 'JQR2C_CONTENT_URL', 	get_option('siteurl') . '/wp-content' );
define( 'JQR2C_PLUGINS_PATH',	JQR2C_CONTENT_URL . '/plugins/' . plugin_basename(dirname(__FILE__)) . '/' );


// ________________________________________________________________________________ INIT OPTIONS

// setting start default value
$jqr2c_init_options	= array(
							'jqr2c_reply' 			=> 'Reply',
							'jqr2c_quote' 			=> 'Quote',
							'jqr2c_jquery' 			=> '0',
							'jqr2c_usephp' 			=> '1',
							'jqr2c_position'		=> 'bottom'
			  			  );
// add to database
add_option(JQR2C_OPTIONSKEY, $jqr2c_init_options, 'jQuery Reply to Comment Options');
// retrive: load setting
$jqr2c_options = get_option( JQR2C_OPTIONSKEY );

/**
 * Add jQuery Javascript include from Google Ajax API repository if set in configuration page (see options)
 * Add jqr2c.css style sheet file. You can edit this file to set layout and appearance.
 * The CSS file is always included in the page
 */
function jqr2_wp_header() {
	global $jqr2c_options;
	//
	if (is_single() && comments_open())	{
		$o = '<!-- Start Of Script Generated By jQuery Reply to Comment ' . JQR2C_VERSION . ' -->'; 
		if(	$jqr2c_options['jqr2c_jquery'] == '1' ) 
			$o .= '<script type="text/javascript" src="http://www.google.com/jsapi"></script>
				   <script type="text/javascript">google.load("jquery", "1.3");</script>';
	
			$o .= '<link type="text/css" href="' . JQR2C_PLUGINS_PATH .'jqr2c.css" rel="stylesheet" />'.
				  '<!-- End Of Script Generated By jQuery Reply to Comment ' . JQR2C_VERSION . ' -->';
	
		echo $o;
	
		?>
		<script type="text/javascript">
		<!--//
		/**
		 * Wordpress jQuery Reply to Comment
		 *
		 * @author			Giovambattista Fazioli
		 * @email			g.fazioli@undolog.com
		 * @url				http://www.undolog.com
		 * 
		 */
		function jqr2c_reply(id) {
			var aut = jQuery('li#'+id).children('cite').text();
			var aco = jQuery('textarea#comment').attr('value');
			jQuery('textarea#comment').attr('value', aco+'<b>@'+aut+'</b>: ').focus();	
		} 
	
		function jqr2c_quote(id) {
			var aut = jQuery('li#'+id).children('cite').text();
			var aco = jQuery('textarea#comment').attr('value');
			var con = jQuery('li#'+id).children('p').text();
			if (window.getSelection)
				var sel = window.getSelection();
			else if (document.getSelection)
				var sel = document.getSelection();
			else if (document.selection) {
				var sel = document.selection.createRange().text; }        
			if(sel!='') con = sel;
			jQuery('textarea#comment').attr('value', (aco+'<b>@'+aut+'</b>:\n<blockquote>'+con+'</blockquote>\n') ).focus();	
		} 
		<?php
		if( $jqr2c_options['jqr2c_usephp'] == '0' ) {	
			if(	$jqr2c_options['jqr2c_jquery'] == '1' ) { ?>
				google.setOnLoadCallback(
			<?php } else { ?>
				jQuery(document).ready(
			<?php } ?>			
					function() {
						jQuery('ol.commentlist').children('li').each(
							function(i,e) {
								var strlinks = '<div class="jqr2c_box"><a class="jqr2c_reply" href="javascript:jqr2c_reply(\''+jQuery(e).attr('id')+'\');"><?=$jqr2c_options['jqr2c_reply']?></a> <a class="jqr2c_quote" href="javascript:jqr2c_quote(\''+jQuery(e).attr('id')+'\');"><?=$jqr2c_options['jqr2c_quote']?></a></div>';
								<?php if( $jqr2c_options['jqr2c_position'] == 'bottom' ) { ?>
								jQuery(e).append(strlinks);
								<?php } else { ?>
								jQuery(e).prepend(strlinks);
								<?php } ?>
							}
						);	
					}
				);
		<?php } ?>			
		//-->
		</script>
		<?php		
	}
}

/**
 * Insert links "reply" and "quote" via PHP. This "filter" is trigged if in control panel
 * the user set "Use PHP".
 *
 * @param		(string)	$c - Wordpress comment content
 * @result		(string)	New Wordpress comment content
 * @wpsystem
 */
function jqr2c_links( $c = '') {
	global $jqr2c_options, $comment;
	// bypass
	if ( !comments_open() || 
		  $jqr2c_options['jqr2c_usephp'] == '0' ||
		  is_admin() || 
		  $comment->comment_type == "trackback" || 
		  $comment->comment_type == "pingback") return $c;
	
	// patch
	$id 	= 'comment-'.$comment->comment_ID;
	$reply	= $jqr2c_options['jqr2c_reply'];
	$quote	= $jqr2c_options['jqr2c_quote'];
	
	$o 		= '<div class="jqr2c_box"><a class="jqr2c_reply" href="javascript:jqr2c_reply(\''.$id.'\');">'.$reply.'</a> <a class="jqr2c_quote" href="javascript:jqr2c_quote(\''.$id.'\');">'.$quote.'</a></div>';
	return ( ($jqr2c_options['jqr2c_position']=='bottom')?($c.$o):($o.$c) );
}


// ________________________________________________________________________________________ OPTIONS

/**
 * Add callback for adding options panel
 */
function jqr2c_add_options_page() {
	if (function_exists('add_options_page')) {
 		add_options_page('jQuery Reply to Comment', 'jQuery Reply to Comment', 8, basename(__FILE__), 'jqr2c_options_subpanel');
	}
}

/**
 * Draw Option Panel
 */
function jqr2c_options_subpanel() {
	global $jqr2c_options, $_POST;
	//
	$any_error = "";
	// check for save setting
	if( isset($_POST['jqr2c_reply'] ) ) {
		$any_error = 'Your settings have been saved.';
		// check any error
		if( $_POST['jqr2c_reply'] == '' || 
			$_POST['jqr2c_quote'] == ''
		   ) {
			$any_error = 'Some field is empty! Check and try again!';
		} else {
			$jqr2c_options['jqr2c_reply'] 		= $_POST['jqr2c_reply'];
			$jqr2c_options['jqr2c_quote'] 		= $_POST['jqr2c_quote'];
			$jqr2c_options['jqr2c_jquery'] 		= isset($_POST['jqr2c_jquery'])?$_POST['jqr2c_jquery']:'0';
			$jqr2c_options['jqr2c_usephp'] 		= isset($_POST['jqr2c_usephp'])?$_POST['jqr2c_usephp']:'0';
			$jqr2c_options['jqr2c_position'] 	= $_POST['jqr2c_position'];
			
			update_option(JQR2C_OPTIONSKEY, $jqr2c_options);
		}
	}
	// show error or OK
	if( $any_error != '') echo '<div id="message" class="updated fade"><p>' . $any_error . '</p></div>';
	// show interface
	$o	= '<style type="text/css">'.
		  '.wrap h3{color:#000;background-color:#e5f3ff;padding:4px 8px}'.
		  '.wrap span{color:#c00;font-weight:bold;margin:0 4px;font-size:12px}'.
		  '</style>'.
		  '<div class="wrap">'.
		  '<h2>jQuery Reply to Comment Settings</h2>'.
		  '<form action="" method="post">'.
		  
		  '<table width="100%" cellpadding="4" cellspacing="0">'.

		  '<tr>'.
		  '<td align="right" nowrap><label for="jqr2c_reply">Reply string:</label></td>'.
		  '<td><input name="jqr2c_reply" id="jqr2c_reply" type="text" size="45" value="'.htmlentities($jqr2c_options['jqr2c_reply']).'" /><span>*</span></td>'.
		  '</tr>'.

		  '<tr>'.
		  '<td align="right" nowrap><label for="jqr2c_quote">Quote string:</label></td>'.
		  '<td><input name="jqr2c_quote" id="jqr2c_quote" type="text" size="45" value="'.htmlentities($jqr2c_options['jqr2c_quote']).'" /><span>*</span></td>'.
		  '</tr>'.

		  '<tr>'.
		  '<td align="right" nowrap><label for="jqr2c_jquery">Include jQuery:</label></td>'.
		  '<td><input '.( ($jqr2c_options['jqr2c_jquery']=='1')?'checked="checked"':'' ).' name="jqr2c_jquery" id="jqr2c_jquery" type="checkbox" value="1" /> (Force jQuery include)</td>'.
		  '</tr>'.

		  '<tr>'.
		  '<td align="right" nowrap><label for="jqr2c_usephp">Use PHP:</label></td>'.
		  '<td><input '.( ($jqr2c_options['jqr2c_usephp']=='1')?'checked="checked"':'' ).' name="jqr2c_usephp" id="jqr2c_usephp" type="checkbox" value="1" /> (Insert Link via PHP)</td>'.
		  '</tr>'.

		  '<tr>'.
		  '<td align="right" nowrap><label for="jqr2c_position">Top:</label></td>'.
		  '<td><input '.( ($jqr2c_options['jqr2c_position']=='top')?'checked="checked"':'' ).' name="jqr2c_position" id="jqr2c_position" type="radio" value="top" /> Bottom: <input '.( ($jqr2c_options['jqr2c_position']=='bottom')?'checked="checked"':'' ).' name="jqr2c_position" id="jqr2c_position" type="radio" value="bottom" /></td>'.
		  '</tr>'.

		  '<tr>'.  
		  '<td colspan="2"><div class="submit"><input type="submit" value="Save Settings" /></div></td>'.
		  '</tr>'.
		  '</table>'.
		  '</form>';
	echo $o;
	?>
		<p style="text-align:center;font-family:Tahoma;font-size:10px">Developed by <a target="_blank" href="http://www.saidmade.com"><img align="absmiddle" src="http://labs.saidmade.com/images/sm-a-80x15.png" border="0" /></a>
			<br/>
			more Wordpress plugins on <a target="_blank" href="http://labs.saidmade.com">labs.saidmade.com</a> and <a target="_blank" href="http://www.undolog.com">Undolog.com</a>
			<br/>
			<form style="text-align:center;width:300px;margin:0 auto" action="https://www.paypal.com/cgi-bin/webscr" method="post">
				<input type="hidden" name="cmd" value="_s-xclick">
				<input type="hidden" name="hosted_button_id" value="3499468">
				<input type="image" src="https://www.paypal.com/it_IT/IT/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - Il sistema di pagamento online più facile e sicuro!">
				<img alt="" border="0" src="https://www.paypal.com/it_IT/i/scr/pixel.gif" width="1" height="1">
			</form>
		</p>				
	</div>
	<?php	
}
 
// ____________________________________________________________________________________________ ACTIONS / FILTERS 

add_action("wp_head", 		'jqr2_wp_header', 1);
add_action('admin_menu', 	'jqr2c_add_options_page');
add_filter('comment_text',	'jqr2c_links', 99);
?>